/*
DDDengine, Connect2001
*/

#include "driver.h"

#include "resource.h"
#include "winsvc.h"
#include "main.h"

int clktime;
int maxgetrm44time;

bool InitDriverConfig() {
char dirstr[1000],currdir[8192];
  GetCurrentDirectory(sizeof(dirstr),currdir);
  strcat(currdir,"\\driver.cfg");

  char inch[128];
  GetPrivateProfileString("RM44","clktime","0x1000",inch,sizeof(inch),currdir);
  sscanf(inch,"%i",&clktime);
  GetPrivateProfileString("PORT","maxgetrm44time","0xa9000",inch,sizeof(inch),currdir);
  sscanf(inch,"%x",&maxgetrm44time);

  DDD_log("CLKTIME: %i\n",clktime);

  return true;
}
BOOL InstallDriver() {
	SC_HANDLE	hSc, hService;
	char		szPath[MAX_PATH];
	UINT		i;

	GetModuleFileName( NULL, szPath, MAX_PATH );
	for( i = strlen( szPath ); i >= 0; i-- )
	{
		if( szPath[i] == '\\' )
		{
			szPath[i + 1] = 0;
			break;
		}
	}

	strcat( szPath, SYSNAMESYS );
  //strcat( szPath, "hwinterfacex64.sys" );

	hSc = OpenSCManager( 
		NULL, 
		NULL, 
		SC_MANAGER_CREATE_SERVICE );

	if( !hSc )
		return FALSE;

	hService = CreateService( 
		hSc, 
		SYSNAME, 
		SYSNAME, 
    //"hwinterfacex64" ,
    //"hwinterfacex64" ,
		SERVICE_ALL_ACCESS, 
		SERVICE_KERNEL_DRIVER, 
		SERVICE_DEMAND_START, 
		SERVICE_ERROR_NORMAL, 
		szPath, 
		NULL, 
		NULL, 
		NULL, 
		NULL, 
		NULL );

	if( !hService )
	{
		CloseServiceHandle( hSc );
    	MessageBox( NULL,"Driver load error!", "Error", MB_ICONERROR | MB_SYSTEMMODAL );
		return ( GetLastError() == ERROR_SERVICE_EXISTS ) ? TRUE : FALSE;
	}
		
	CloseServiceHandle( hSc );
	InitDriverConfig();
	return TRUE;
}

BOOL StartDriver()
{
	SC_HANDLE	hSc, hService;

	hSc = OpenSCManager( 
		NULL, 
		NULL, 
		SC_MANAGER_CREATE_SERVICE );

	if( hSc == NULL )
		return FALSE;

	hService = OpenService( 
		hSc, 
		SYSNAME, 
    //"hwinterfacex64" ,
		SERVICE_START );

	if( !hService )
	{
		CloseServiceHandle( hSc );
		return FALSE;
	}

	StartService( hService, NULL, NULL );
	return TRUE;
}

BOOL UninstallDriver()
{
	SC_HANDLE		hSc, hService;
	SERVICE_STATUS	ss;

	hSc = OpenSCManager( 
		NULL, 
		NULL, 
		SC_MANAGER_CREATE_SERVICE );

	if( hSc == NULL )
		return FALSE;

	hService = OpenService( 
		hSc, 
		SYSNAME, 
    //"hwinterfacex64" ,
		SERVICE_ALL_ACCESS );

	if( !hService )
	{
		CloseServiceHandle( hSc );
		return FALSE;
	}

	bool res;
	res=ControlService( hService, SERVICE_CONTROL_STOP, &ss );
	res=DeleteService( hService );
	res=CloseServiceHandle( hSc );
	return TRUE;
}
